
import { createStore } from 'vuex'
import { orgFn } from '@/api/org'
import { ExternalSERVEICE, WithinSERVEICE } from '../../public/config'

const keys = { USER: 'user', ENTERPRISE:'enterprise', SERVEICE:'SERVEICE' }
function getUserInfo(state) {
  if (state.userInfo) return state.userInfo;
  let userInfo = localStorage.getItem(keys.USER);
  if (userInfo) {
    state.userInfo = JSON.parse(userInfo);
  }
  return state.userInfo;
}
function getEnterprise(state){
  if (state.enterprise) return state.enterprise;
  let enterprise = localStorage.getItem(keys.ENTERPRISE);
  if (enterprise) {
    state.enterprise = JSON.parse(enterprise);
  }
  return state.enterprise;
}
function getSERVEICE(state){
  
  if (state.SERVEICE) return state.SERVEICE;
  let ip = localStorage.getItem(keys.SERVEICE);
  if (ip) {
    state.SERVEICE = ip;
  }else{
    state.SERVEICE = WithinSERVEICE;
  }
  return state.SERVEICE;
}
const store = createStore({
  state: {
    data: {},
    permission: [],
    isLoading: false,
    userInfo: null,
    enterpriseId: null,
    menus:[],
    //供热企业列表
    enterprise:[],
    //设置侧边栏默认为打开状态
    iscollapse:false,
    SERVEICE: null
  },
  mutations: {
    setSERVEICE(state, ip){
      if(ip === "111.160.132.74" || ip === "218.69.97.198"){
        state.SERVEICE = WithinSERVEICE;
      }else{
        state.SERVEICE = ExternalSERVEICE;
      }
      
      localStorage.setItem(keys.SERVEICE, state.SERVEICE);
    },
    //修改导航菜单
    setMenus(state,menus){
      state.menus=menus
    },
    //修改侧边栏状态
    setAsideWidth(state){
      state.iscollapse=!state.iscollapse
    },
    setPermission(state, data) {  //调用方式 this.$store.commit('setPermission', data)
      if (!data || typeof data != 'object') return;
      if (data instanceof Array) {
        state.permission.push(...data);
      } else {
        state.permission = data;
      }
    }, setUserInfo(state, data) {
      state.userInfo = data;
      localStorage.setItem(keys.USER, JSON.stringify(data));
    },
    clearUserInfo(state) {
      state.permission = [];
      state.userInfo = null;
      localStorage.removeItem(keys.USER);
      //sessionStorage.clear();
    },
    updateLoadingState(state, flag) {
      state.isLoading = flag
    },
    setEnterpriseId(state, data){
      state.enterpriseId = data;
      localStorage.setItem("enterpriseId", data);
    },
    setEnterprise(state, data){
      state.enterprise = data;
      localStorage.setItem(keys.ENTERPRISE, JSON.stringify(data));
    }
  }, getters: {
    getSERVEICE: (state) => () => {  
      getSERVEICE(state);
      if(state.SERVEICE){
        return state.SERVEICE;
      }
      return '未获取到接口ip';
    },
    getPermission: (state) => (path) => {  //调用方式 store.getters.getPermission('sys_User')
      if (!path) return state.permission;
      return state.permission.find(x => x.path == path);
    },
    getUserInfo: (state) => () => {
      getUserInfo(state);
      return state.userInfo;
    }, getUserName: (state) => () => {
      getUserInfo(state);
      if (state.userInfo) {
        return state.userInfo.userName;
      }
      return '未获取到登陆信息';
    },
    getToken: (state) => () => {
      getUserInfo(state);
      if (state.userInfo) {
        return state.userInfo.token;
      }
      return '';
    },
    getEnterpriseId:(state) =>()=>{
      let id = localStorage.getItem("enterpriseId");
      if(id){
        state.enterpriseId = id;
      }else{
        state.enterpriseId = state.userInfo.enterpriseId;
      }
      return state.enterpriseId;
    },
    getEnterprise:(state)=>()=>{
      getEnterprise(state);
      if(state.enterprise){
        return state.enterprise;
      }
      return '未获取到企业信息';
    },
    isLogin: (state) => () => {
      if (getUserInfo(state)) {
        return true;
      }
      return false;
    },
    isLoading: (state) => () => {
      return state.isLoading;
    },
    data: (state) => () => {
      return state.data;
    },
    getData: (state) => () => {
      return state.data;
    },
  }, actions: {
    setPermission(context, data) {
      context.commit('setPermission', data); 
    },
    toDo(context) {
      return context.Store.m;
    },
    onLoading(context, flag) {
      context.commit("updateLoadingState", flag);
    },
    setEnterprise(context, data){
      context.commit('setEnterprise', data);
    },
    setEnterpriseId(context, data){
      context.commit('setEnterpriseId', data);
    },
    getOrg(context){
        //actions里面的方法是异步操作
        //异步操作就使用promise
        return new Promise((resolve,reject)=>{
          orgFn().then(res=>{
            //console.log(res)
            context.commit('setEnterprise',res.data) 
            context.commit('setEnterpriseId',res.data[0].enterpriseId) 
            resolve(res)
          }).catch(err=>reject(err))
        })   
    }
  }
})
export default store